TYPE
  LOGLEVEL : (CRITICAL, WARNING, INFO, DEBUG) := INFO;
END_TYPE

FUNCTION_BLOCK LOGGER
  VAR_INPUT
    TRIG : BOOL;
    MSG : STRING;
    LEVEL : LOGLEVEL := INFO;
  END_VAR
  VAR
    TRIG0 : BOOL;
  END_VAR

  IF TRIG AND NOT TRIG0 THEN
  {{
   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  }}
  END_IF;
  TRIG0:=TRIG;
END_FUNCTION_BLOCK



FUNCTION_BLOCK python_eval
  VAR_INPUT
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    STATE : DWORD;
    BUFFER : STRING;
    PREBUFFER : STRING;
    TRIGM1 : BOOL;
    TRIGGED : BOOL;
  END_VAR

  {extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);}
END_FUNCTION_BLOCK

FUNCTION_BLOCK python_poll
  VAR_INPUT
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    STATE : DWORD;
    BUFFER : STRING;
    PREBUFFER : STRING;
    TRIGM1 : BOOL;
    TRIGGED : BOOL;
  END_VAR

  {extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);}
END_FUNCTION_BLOCK

FUNCTION_BLOCK python_gear
  VAR_INPUT
    N : UINT;
    TRIG : BOOL;
    CODE : STRING;
  END_VAR
  VAR_OUTPUT
    ACK : BOOL;
    RESULT : STRING;
  END_VAR
  VAR
    py_eval : python_eval;
    COUNTER : UINT;
    ADD10_OUT : UINT;
    EQ13_OUT : BOOL;
    SEL15_OUT : UINT;
    AND7_OUT : BOOL;
  END_VAR

  ADD10_OUT := ADD(COUNTER, 1);
  EQ13_OUT := EQ(N, ADD10_OUT);
  SEL15_OUT := SEL(EQ13_OUT, ADD10_OUT, 0);
  COUNTER := SEL15_OUT;
  AND7_OUT := AND(EQ13_OUT, TRIG);
  py_eval(TRIG := AND7_OUT, CODE := CODE);
  ACK := py_eval.ACK;
  RESULT := py_eval.RESULT;
END_FUNCTION_BLOCK


FUNCTION_BLOCK GeneratoreOnda
  VAR_INPUT
    IN : BOOL;
  END_VAR
  VAR_OUTPUT
    OUT : BOOL;
  END_VAR
  VAR
    TEMP : BOOL;
    STATO : BOOL;
    TIMERON : TON;
    TIMEROFF : TON;
    TIMEON : TIME := T#4s;
    TIMEOFF : TIME := T#6s;
    R_TRIG1 : R_TRIG;
    R_TRIG2 : R_TRIG;
  END_VAR

  R_TRIG1(CLK := IN);
  IF STATO AND R_TRIG1.Q THEN
    TEMP := FALSE; (*reset*)
  END_IF;
  R_TRIG2(CLK := IN);
  IF NOT(STATO) AND R_TRIG2.Q THEN
    TEMP := TRUE; (*set*)
  END_IF;
  STATO := TEMP;
  IF NOT(STATO) OR NOT(STATO) THEN
    OUT := FALSE; (*reset*)
  END_IF;
  OUT := STATO AND NOT(TIMERON.Q);
  TIMERON(IN := NOT(TIMEROFF.Q) AND STATO, PT := TIMEON);
  TIMEROFF(IN := TIMERON.Q AND STATO, PT := TIMEOFF);
END_FUNCTION_BLOCK

PROGRAM MainProgram
  VAR
    MyGen : GeneratoreOnda;
    Ingresso : BOOL;
    Uscita : BOOL;
  END_VAR

  MyGen(IN:=Ingresso);
  Uscita := MyGen.OUT;
END_PROGRAM


CONFIGURATION Config0

  RESOURCE Res0 ON PLC
    TASK CicloACopiaMassiva(INTERVAL := T#100ms,PRIORITY := 0);
    PROGRAM instance0 WITH CicloACopiaMassiva : MainProgram;
  END_RESOURCE
END_CONFIGURATION
