FUNCTION_BLOCK GeneratoreOnda
  VAR_INPUT
    IN : BOOL;
  END_VAR
  VAR_OUTPUT
    OUT : BOOL;
  END_VAR
  VAR
    TEMP : BOOL;
    STATO : BOOL;
    TIMERON : TON;
    TIMEROFF : TON;
    TIMEON : TIME := T#4s;
    TIMEOFF : TIME := T#6s;
    R_TRIG1 : R_TRIG;
    R_TRIG2 : R_TRIG;
  END_VAR

  R_TRIG1(CLK := IN);
  IF STATO AND R_TRIG1.Q THEN
    TEMP := FALSE; (*reset*)
  END_IF;
  R_TRIG2(CLK := IN);
  IF NOT(STATO) AND R_TRIG2.Q THEN
    TEMP := TRUE; (*set*)
  END_IF;
  STATO := TEMP;
  IF NOT(STATO) OR NOT(STATO) THEN
    OUT := FALSE; (*reset*)
  END_IF;
  OUT := STATO AND NOT(TIMERON.Q);
  TIMERON(IN := NOT(TIMEROFF.Q) AND STATO, PT := TIMEON);
  TIMEROFF(IN := TIMERON.Q AND STATO, PT := TIMEOFF);
END_FUNCTION_BLOCK

PROGRAM MainProgram
  VAR
    MyGen : GeneratoreOnda;
    Ingresso : BOOL;
    Uscita : BOOL;
  END_VAR

  MyGen(IN:=Ingresso);
  Uscita := MyGen.OUT;
END_PROGRAM


CONFIGURATION Config0

  RESOURCE Res0 ON PLC
    TASK CicloACopiaMassiva(INTERVAL := T#100ms,PRIORITY := 0);
    PROGRAM instance0 WITH CicloACopiaMassiva : MainProgram;
  END_RESOURCE
END_CONFIGURATION
